#include <stdio.h>
#include <stdlib.h>

int main(int argc, char **argv)
{


  FILE * fp = stdout;
  int num_of_dunk;
  int num_of_toilets;
  int i,j,k;
  char fname[100];
  char * err[1];
  

  if ((argc <= 2) || (argc >3)) {
    fprintf(stderr,"Usage: %s #of_dunk #of toilets\n",argv[0]);
    exit(1);
  }
  num_of_dunk = strtol(argv[1],err, 10);
  if ((strcmp(err[0], "") != 0) || (num_of_dunk < 1)) {
    fprintf(stderr,"Usage: %s #of_dunk #of toilets\n",argv[0]);
    exit(1);
  }

  num_of_toilets = strtol(argv[2],err, 10);
  if ((strcmp(err[0], "") != 0) || (num_of_toilets < 1)) {
    fprintf(stderr,"Usage: %s #of_dunk #of toilets\n",argv[0]);
    exit(1);
  }

  sprintf(fname,"bmtc_log_%s_%s.smv",argv[1], argv[2]);
  if ((fp = fopen(fname,"w")) == NULL) {
    perror(fname);
    exit(1);
  }

  fprintf(fp, "-- Bomb in Multiple Toilets with Clogging\n");
  fprintf(fp, "-- Called as: %s %s %s\n\n",argv[0], argv[1], argv[2]);
  fprintf(fp, "-- bmtc_log_%s_%s\nMODULE main\n\n",argv[1], argv[2]);
  fprintf(fp, "IVAR\nact : {\n\twait,");
  for (i=1;i<=num_of_dunk;i++)
    for(j=1;j<=num_of_toilets;j++)
      if ((j == 1) && (i == 1)) {
	fprintf(fp, "\n\tdunk_%d_%d",i,j);
      } else {
	fprintf(fp, ",\n\tdunk_%d_%d",i,j);
      }
  for (i = 1; i<= num_of_toilets; i++)
    fprintf(fp, ",\n\tflush_%d",i);
  fprintf(fp, "\n      };\n\n");

  for (i=1;i<=num_of_dunk;i++) {
    fprintf(fp, "\nDEFINE dunk_package_%d := act in {",i);
    for(j=1;j<=num_of_toilets;j++)
      if (j != num_of_toilets) {
	fprintf(fp, "\n\tdunk_%d_%d,",i,j);
      } else {
	fprintf(fp, "\n\tdunk_%d_%d",i,j);
      }
    fprintf(fp, "\n };\n");
  }

  for(j=1;j<=num_of_toilets;j++) {
    fprintf(fp, "DEFINE dunk_in_toilet_%d := act in {",j);
    for (i=1;i<=num_of_dunk;i++)
      if (i != num_of_dunk) {
	fprintf(fp, "\n\tdunk_%d_%d,",i,j);
      } else {
	fprintf(fp, "\n\tdunk_%d_%d",i,j);
      }
    fprintf(fp, "\n };\n");
  }


  fprintf(fp, "\nVAR\n\tPos : 1..%d;",num_of_dunk);
  for (j = 1;j<=num_of_toilets;j++)
    fprintf(fp, "\n\tClogged_%d : boolean;",j,num_of_dunk,j);
  fprintf(fp, "\n\tDefused : boolean;\n\n");

  for(i=1;i<=num_of_toilets;i++)
    fprintf(fp, "TRANS dunk_in_toilet_%d -> !Clogged_%d\n",i,i);

  fprintf(fp, "\nASSIGN next(Pos) := Pos;\n");

  for (j = 1; j <= num_of_toilets;j++) {
    fprintf(fp, "\nASSIGN next(Clogged_%d) := \n case\n",j);
    fprintf(fp, "  dunk_in_toilet_%d : 1;\n",j);
    fprintf(fp, "  act = flush_%d : 0;\n",j);
    fprintf(fp, "  1 : Clogged_%d;\n esac;\n",j);
  }

  fprintf(fp, "\nASSIGN next(Defused) :=\n case\n");
  for (i=1;i<=num_of_dunk;i++) {
    fprintf(fp, "  dunk_package_%d & Pos = %d : 1;\n",i,i);  
  }
  fprintf(fp, "  1 : Defused;\n esac;\n");

  fprintf(fp, "\nINIT !Defused\n");  
  fprintf(fp, "NULL_OBS_STRONG_GOAL Defused\n");
  fclose(fp);
}



